from typing import Generic, TypeVar

from rainbowadn.chain.abstractreductionchainmetafactory import AbstractReductionChainMetaFactory
from rainbowadn.chain.block import Block
from rainbowadn.chain.reduction.reduction import Reduction
from rainbowadn.chain.reduction.reductionchainfactory import ReductionChainFactory
from rainbowadn.chain.reduction.reductionprotocol import ReductionProtocol
from rainbowadn.chain.stages.stage import StateStage
from rainbowadn.hashing.rainbow_factory import RainbowFactory

__all__ = ('ReductionChainMetaFactory',)

ReductorType = TypeVar('ReductorType')
AccumulatorType = TypeVar('AccumulatorType')


class ReductionChainMetaFactory(
    AbstractReductionChainMetaFactory[
        Block[
            ReductorType,
            StateStage[
                ReductorType,
                AccumulatorType,
                Reduction[ReductorType, AccumulatorType]
            ]
        ],
        ReductorType,
        AccumulatorType
    ],
    Generic[ReductorType, AccumulatorType]
):
    def factory(
            self,
            reductor_factory: RainbowFactory[ReductorType],
            accumulator_factory: RainbowFactory[AccumulatorType],
            protocol: ReductionProtocol[ReductorType, AccumulatorType],
    ):
        return ReductionChainFactory(
            reductor_factory,
            accumulator_factory,
            protocol,
        )
