from typing import Generic, TypeVar

from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.hashresolver import HashResolver
from rainbowadn.hashing.nullability.nullablereference import NullableReference

__all__ = ('StateProtocol',)

HeaderType = TypeVar('HeaderType')
StateType = TypeVar('StateType')


class StateProtocol(Generic[HeaderType, StateType]):
    def __init__(self, resolver: HashResolver):
        assert isinstance(resolver, HashResolver)
        self.resolver = resolver

    def verify(
            self,
            previous: NullableReference[StateType],
            header: HashPoint[HeaderType],
            state: NullableReference[StateType]
    ) -> bool:
        raise NotImplementedError
