import abc
from typing import Generic, TypeVar

from rainbowadn.data.collection.trees.comparison.comparator import Comparator, Equal
from rainbowadn.hashing.hashresolver import HashResolver

__all__ = ('ProtocolComparator',)

KeyType = TypeVar('KeyType')


class ProtocolComparator(Comparator[KeyType], abc.ABC, Generic[KeyType]):
    def __init__(self, resolver: HashResolver, equal: Equal):
        assert isinstance(resolver, HashResolver)
        assert isinstance(equal, Equal)
        super().__init__(resolver)
        self.equal = equal
