from rainbowadn.hashing.hashpoint import HashPoint
from rainbowadn.hashing.hashresolver import HashResolver
from rainbowadn.hashing.recursivementionable import RecursiveMentionable

__all__ = ('hash_point_format', 'tabulate',)


def hash_point_format(hash_point: HashPoint, resolver: HashResolver, tab: int) -> str:
    assert isinstance(hash_point, HashPoint)
    assert isinstance(resolver, HashResolver)
    assert isinstance(tab, int)
    value = resolver.resolve(hash_point)
    if isinstance(value, RecursiveMentionable):
        return value.str(resolver, tab)
    else:
        return str(value)


newline = False


def tabulate(tab: int) -> str:
    assert isinstance(tab, int)
    if newline:
        return '\n' + '    ' * tab
    else:
        return ' '
